function X_dct = DCT(x)
    N = length(x);
    Q = floor(N/2);
    x_even = x(1:Q+1);

    % DCT - Based on the definition  
    n = 0:Q;
    m = n';
    kn = ones(1,Q+1)*2;
    kn(1) = 1;
    kn(end) = 1;
    kn = repmat(kn,Q+1,1);

    W = cos(pi/Q * m * n) .* kn;
    X_dct = W * x_even';
end
